package lab5;
import java.util.ArrayList;

public class Main
{

    public static void main(String[] args)
    {
        example1();
        example2();
    }

    static void example1()
    {
        CNFSubClause c1 = new CNFSubClause();
        CNFSubClause c2 = new CNFSubClause();
        
        //Construct the clause (l1 OR l2 OR l3)
        c1.getLiterals().add(new Literal("l1", false));
        c1.getLiterals().add(new Literal("l2", false));
        c1.getLiterals().add(new Literal("l3", false));

        //Construct the clause (m1 OR !l1 OR m3 OR !m4)
        c2.getLiterals().add(new Literal("m1", false));
        c2.getLiterals().add(new Literal("l1", true));
        c2.getLiterals().add(new Literal("m3", false));
        c2.getLiterals().add(new Literal("m4", true));

        System.out.println("This is c1...");
        c1.print();

        System.out.println("This is c2...");
        c2.print();

        System.out.println("This is the result of resolution between (c1, c2)");

        ArrayList<CNFSubClause> newClauses = CNFSubClause.resolve(c1, c2);

        for(int i = 0; i < newClauses.size(); i++)
        {
            newClauses.get(i).print();
        }

    }

    static void example2()
    {
        CNFSubClause A1 = new CNFSubClause();
        CNFSubClause A2 = new CNFSubClause();
        CNFSubClause A3 = new CNFSubClause();
        CNFSubClause A4 = new CNFSubClause();

        A1.getLiterals().add(new Literal("P21", true));
        A1.getLiterals().add(new Literal("B11", false));

        System.out.println("This is a sub-clause...");
        A1.print();

        A2.getLiterals().add(new Literal("B11", true));
        A2.getLiterals().add(new Literal("P12", false));
        A2.getLiterals().add(new Literal("P21", false));

        System.out.println("This is a sub-clause...");
        A2.print();

        A3.getLiterals().add(new Literal("P12", true));
        A3.getLiterals().add(new Literal("B11", false));

        System.out.println("This is a sub-clause...");
        A3.print();

        A4.getLiterals().add(new Literal("B11", true));

        System.out.println("This is a sub-clause...");
        A4.print();

        CNFClause KB = new CNFClause();
        KB.getSubClauses().add(A1);
        KB.getSubClauses().add(A2);
        KB.getSubClauses().add(A3);
        KB.getSubClauses().add(A4);

        Literal a = new Literal("P12", true);
        System.out.println("--------------------------");
        System.out.println();

        boolean result = resolution(KB, a);
        a.print();
        System.out.println("is " + result);

    }

    static boolean resolution(CNFClause KB, Literal a)
    {
        CNFClause clauses = new CNFClause();
        clauses.getSubClauses().addAll(KB.getSubClauses());

        Literal notA = new Literal(a.getName(), !a.isNegated());
        CNFSubClause aClause = new CNFSubClause();
        aClause.getLiterals().add(notA);
        clauses.getSubClauses().add(aClause);

        while(true)
        {
            ArrayList<CNFSubClause> newS = new ArrayList<CNFSubClause>();
            ArrayList<CNFSubClause> subClauses = clauses.getSubClauses();

            for(int i = 0; i < subClauses.size(); i++)
            {
                CNFSubClause Ci = subClauses.get(i);

                for(int j = i+1; j < subClauses.size(); j++)
                {
                    CNFSubClause Cj = subClauses.get(j);

                    ArrayList<CNFSubClause> resolvents = CNFSubClause.resolve(Ci, Cj); // resolution.

                    for(CNFSubClause resolvent: resolvents)
                    {
                        //...and if an empty subclause has been generated we have reached contradiction; and the literal has been proved
                        if(resolvent.isEmpty())
                        {
                            System.out.println("------------------");
                            System.out.println("Resolution between");
                            Ci.print();
                            System.out.println("and ");
                            Cj.print();
                            System.out.println("produced:");
                            System.out.println("Empty sub-clause!");
                            System.out.println("------------------");
                            return true;
                        }

                        //All clauses produced that don't exist already are added
                        if(!newS.contains(resolvent) && !clauses.contains(resolvent))
                        {
                            System.out.println("------------------");
                            System.out.println("Resolution between");
                            Ci.print();
                            System.out.println("and ");
                            Cj.print();
                            System.out.println("produced:");
                            resolvent.print();
                            newS.add(resolvent);
                            System.out.println("------------------");
                        }
                    }
                }
            }

            boolean newClausesFound = false;
            //Check if any new clauses were produced in this loop
            if(newS.size()>0)
            {
            	clauses.getSubClauses().addAll(newS);
                newClausesFound = true;
            }
            

            //If not, then Knowledge Base does not logically infer the literal we wanted to prove
            if(!newClausesFound)
            {
                System.out.println("New clauses were not found.");
                return false;
            }
        }
    }
}
